%*************************************************************************
%  Robustesse_LQ_LQG_discrete :
%    Etude de la robustesse de la commande LQ et de la commande LQG, dans
%    le cas discret
%*************************************************************************
%
%  Auteur : E. Ostertag  27 juin 2005  
%
% 1) Etude de la robustesse de la commande LQ (sans filtre)
%
% a) Trac du cercle unit et du cercle "interdit" au diagramme de Nyquist
%
figure; theta = 0:2*pi/360:2*pi;
set(gca,'DefaultLineLineWidth',1.5);
axis([-2 1 -1 1]);
axis equal; axis manual;  hold on;
plot(cos(theta),sin(theta),'g');			% Trac du cercle unit
rho = 1/sqrt(1+(1/R)*Gamma'*P*Gamma);
plot(-1 + rho*cos(theta),rho*sin(theta),'r'); % Trac du cercle "interdit"
%
% b) Trac sur la mme figure du diagramme de Nyquist de la boucle ouverte corrige,
%    sans filtre dans la boucle; plage de pulsations adquate : 0,01 rad/s  pi/Te
%
Tbo_ss = ss(Phi,Gamma,L,D,Te);			% Boucle ouverte corrige
nbpoints = 400; decmin = -2; decmax = log10(pi/Te);
omega = logspace(decmin,decmax,nbpoints);
[Re,Im] = nyquist(Tbo_ss,omega);		% Calcul du lieu de Nyquist
Re_Tbo = zeros(1,nbpoints); Im_Tbo = zeros(1,nbpoints);
Re_Tbo(:) = Re(1,1,:); Im_Tbo(:) = Im(1,1,:);
plot(Re_Tbo,Im_Tbo,'b'); 	grid on;	% Trac du lieu de Nyquist
