%*************************************************************************
%  Robustesse_LQ_continue :
%    Etude de la robustesse de la commande LQ continue
%*************************************************************************
%
%  Auteur : E. Ostertag  27 juin 2005  
%

% 1) Trac du cercle "interdit" au diagramme de Nyquist
%
figure; theta = 0:2*pi/360:2*pi;
set(gca,'DefaultLineLineWidth',1.5);
axis([-5 1 -2 2]);
axis equal; axis manual; hold on; grid on;
plot(-1 + cos(theta),sin(theta),'r'); % Trac du cercle "interdit"
%
% 2) Trac sur la mme figure du diagramme de Nyquist de la boucle ouverte corrige 
%    plage de pulsations adquate : 0,1 rad/s  100 rad/s
%
Tbo_ss = ss(A,B,L,0);			% Boucle ouverte corrige
nbpoints = 400; decmin = -1; decmax = 2;
omega = logspace(decmin,decmax,nbpoints);
[Re,Im] = nyquist(Tbo_ss,omega);		% Calcul du lieu de Nyquist
Re_Tbo = zeros(1,nbpoints); Im_Tbo = zeros(1,nbpoints);
Re_Tbo(:) = Re(1,1,:); Im_Tbo(:) = Im(1,1,:);
plot(Re_Tbo,Im_Tbo,'b'); plot(Re_Tbo,-Im_Tbo,'m');	% Trac du lieu de Nyquist
